<template>
  <span v-if="stopPropagation" @click.capture.stop="_handle">
    <slot />
  </span>
  <span v-else @click="_handle">
    <slot />
  </span>
</template>

<script>
import { WebSocketEventBus } from "./WebSocketEventBus";

export default {
  name: "on-click",
  props: {
    configurationId: String,
    type: String,
    payload: Object,
    intent: String,
    stopPropagation: Boolean,
    onMessage: Function,
    onOpen: Function,
    onError: Function,
    onClose: Function,
    disabled: Boolean,
  },
  data() {
    return {
      interaction: null,
    };
  },
  methods: {
    _handle: function () {
      if (!this.configurationId) {
        console.error("[OnClick] Missing configurationId prop!");
        return;
      }
      if (this.disabled) {
        return;
      }
      let message = {
        type: this.type || "data",
        payload: this.payload,
      };
      if (this.intent) {
        message.payload = { ...message.payload, intent: this.intent };
      }
      let packet = {
        configurationId: this.configurationId,
        message,
      };
      console.debug(
        `[OnClick]: About to send: ${JSON.stringify(message)} to: ${
          this.configurationId
        }`
      );
      WebSocketEventBus.$emit("send", packet);
    },
  },

  mounted() {
    WebSocketEventBus.$emit("connect", {
      configurationId: this.configurationId,
      interaction: localStorage.getItem("mmcc-interaction") || null,
    });
    WebSocketEventBus.onClose(this.onClose);
    WebSocketEventBus.onOpen(this.onOpen);
    WebSocketEventBus.onError(this.onError);
  },
};
</script>
